/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
import { defineComponent as S, createVNode as e } from "vue";
import { Popup as b } from "@progress/kendo-vue-popup";
import { getDefaultSlots as y } from "@progress/kendo-vue-common";
const D = /* @__PURE__ */ S({
  name: "list-container",
  emits: {
    mousedown: null,
    blur: null,
    open: null,
    close: null
  },
  props: {
    width: [String, Number],
    dir: String,
    itemsCount: Number,
    popupSettings: {
      type: Object,
      default: function() {
        return {
          animate: !0,
          height: "200px"
        };
      }
    }
  },
  created() {
    this.kendoAnchorRef = void 0;
  },
  methods: {
    onMouseDown(o) {
      this.$emit("mousedown", o);
    },
    onBlur(o) {
      this.$emit("blur", o);
    },
    onOpen(o) {
      this.$emit("open", o);
    },
    onClose(o) {
      this.$emit("close", o);
    }
  },
  render() {
    const o = y(this), {
      width: n,
      dir: i,
      popupSettings: s
    } = this.$props, {
      popupClass: p,
      className: l,
      animate: r,
      anchor: u,
      anchorAlign: d,
      show: a,
      itemsCount: A,
      appendTo: h,
      collision: c,
      direction: m,
      offset: f,
      popupAlign: w,
      style: g,
      width: t,
      popupStyle: C
    } = s;
    return e(b, {
      ref: "popup",
      style: {
        ...g,
        width: t || n,
        direction: i
      },
      popupClass: l,
      animate: r,
      anchor: u,
      anchorAlign: d,
      show: a,
      onOpen: this.onOpen,
      onClose: this.onClose,
      appendTo: h,
      collision: c,
      direction: m,
      offset: f,
      popupAlign: w
    }, {
      default: () => [e("div", {
        class: p,
        style: C,
        onMousedown: this.onMouseDown,
        onFocusout: this.onBlur
      }, [o])]
    });
  }
});
export {
  D as ListContainer
};
