/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use strict";var u=Object.defineProperty;var d=(a,e,t)=>e in a?u(a,e,{enumerable:!0,configurable:!0,writable:!0,value:t}):a[e]=t;var p=(a,e,t)=>d(a,typeof e!="symbol"?e+"":e,t);const g=require("./VirtualScroll.js"),m=require("./Navigation.js"),r=require("./utils.js"),c=require("@progress/kendo-vue-common"),f=require("../package-metadata.js");class h{constructor(e){p(this,"vs",new g);p(this,"navigation",new m.Navigation);p(this,"handleItemClick",(e,t)=>{const n=this.initState();n.event=t,this.component.handleItemSelect(e,n),this.togglePopup(n),this.applyState(n)});p(this,"handleFocus",e=>{if(!this.component.currentFocused){const t=this.initState();t.data.currentFocused=!0,t.events.push({type:"focus"}),t.event=e,this.applyState(t)}});p(this,"filterChanged",(e,t)=>{const n=this.component,{textField:i,filterable:s}=n.$props;s&&(t.events.push({type:"filterchange",filter:{field:i,operator:"contains",ignoreCase:!0,value:e}}),this.repositionPopup())});p(this,"togglePopup",e=>{const t=this.component.$props,n=t.opened!==void 0?t.opened:this.component.currentOpened;t.opened===void 0&&(e.data.currentOpened=!n),n?e.events.push({type:"close"}):(e.events.push({type:"open"}),this.calculatePopupWidth())});p(this,"pageChange",(e,t)=>{const n=this.initState();n.event=t,this.triggerOnPageChange(n,e.skip,e.take),this.applyState(n)});p(this,"scrollChange",e=>{this.component.$emit("scroll",e)});p(this,"scrollToVirtualItem",(e,t)=>{const n=this.vs;if(n.enabled=!1,e.skip===0)n.reset();else if(e.skip+e.pageSize===e.total)n.scrollToEnd();else{let i=n.translate;i===0&&(n.calcScrollElementHeight(),i=n.itemHeight*e.skip,n.translateTo(i-n.itemHeight)),n.container&&(n.container.scrollTop=i),this.scrollToItem(t,!0)}setTimeout(()=>n.enabled=!0,10)});p(this,"getGroupedDataModernMode",(e,t)=>{const n=[];return e.forEach((i,s)=>{e[s-1]&&i[t]!==e[s-1][t]&&n.push({[t]:i[t]}),n.push(e[s])}),n});p(this,"resetGroupStickyHeader",(e,t)=>{const n=this.initState();e!==t.group&&t.state&&(t.state.data.group=e,this.applyState(n))});c.validatePackage(f.packageMetadata),this.listBoxId=c.guid(),this.guid=c.guid(),this.component=e,this.vs.PageChange=this.pageChange,this.vs.ScrollChange=this.scrollChange}didMount(){const e=this.component.$props,t=e.popupSettings,n=e.style,i=t&&t.width;let s=e.opened===!0;i===void 0&&this.calculatePopupWidth(),e.dir===void 0&&n&&n.direction===void 0&&(this.calculateDir(),s=!0),s&&this.component.$forceUpdate()}calculateDir(){this.component.element&&(this.dirCalculated=window.getComputedStyle(this.component.element).direction||void 0)}calculatePopupWidth(){const e=this.component.$props,t=e.popupSettings,n=t&&t.width;this.wrapper&&!n&&(this.component.popupWidth=e.popupSettings.width!==void 0?e.popupSettings.width:this.wrapper.offsetWidth+"px")}scrollToItem(e,t){const n=this.list||this.vs.list,i=n?n.children[0]:void 0;if(i&&e>=0){const s=this.vs,o=s.container||n.parentNode;if(o){const l=t!==void 0?t:s.enabled;r.scrollToItem(o,i.offsetHeight,e,s.translate,l)}}}repositionPopup(){const e=this.component;setTimeout(function(){const t=e.$refs.container;if(t){const n=t.$refs.popup;n&&n.show&&n.reposition()}},5)}initState(){return{data:{},events:[],event:void 0}}applyState(e){Object.keys(e.data).length>0&&Object.keys(e.data).forEach(i=>{this.component[i]=e.data[i]});const t=this.component.primitiveValue(),n={event:e.event,component:this.component,target:{name:this.component.$props.name,value:t},value:t};e.events.forEach(i=>{const{type:s}=i;delete i.type,s&&(s==="change"&&(this.component.$emit("changemodel",t),this.component.$emit("update:modelValue",t)),this.component.$emit(s,{...n,...i}))})}triggerOnPageChange(e,t,n){const i=this.component.$props.virtual;if(i){const s=Math.min(Math.max(0,t),Math.max(0,i.total-n));s!==i.skip&&e.events.push({type:"pagechange",page:{skip:s,take:n}})}}triggerPageChangeCornerItems(e,t){const n=this.component.$props,{dataItems:i=[],dataItemKey:s,virtual:o}=n,l=n.opened!==void 0?n.opened:this.component.currentOpened;e&&o&&this.vs.enabled&&(o.skip>0&&r.areSame(e,i[0],s)?this.triggerOnPageChange(t,o.skip-1,o.pageSize):o.skip+o.pageSize<o.total&&r.areSame(e,i[i.length-1],s)?this.triggerOnPageChange(t,o.skip+1,o.pageSize):!l&&o.skip+o.pageSize<o.total&&r.areSame(e,i[i.length-1],s)&&this.triggerOnPageChange(t,o.skip+1,o.pageSize))}getTemplateDef(e,t){const n=c.templateRendering.call(this,e,c.getListeners.call(this));return c.getTemplate.call(this,{h:t,template:n})}getListItemHeight(e){const t=e&&window.getComputedStyle(e);return t?t.height.slice(0,t.height.length-2):0}}p(h,"defaultProps",{popupSettings:{animate:!0,height:"200px"},required:!1,validityStyles:!0});module.exports=h;
